Name:       	libtota
Summary:    	fota update library
Version:    	1.2.7
Release:    	0
Group:      	System
License:    	Apache-2.0 and BSD-2-Clause and BSD-3-Clause and PD
Source0:    	%{name}-%{version}.tar.gz

BuildRequires:	cmake
BuildRequires:	pkgconfig(liblzma-tool)

%description
Fota update agent which update firmware using delta files

%package devel
License:        Apache-2.0 and BSD-2-Clause and BSD-3-Clause and PD
Summary:        libtota library (development)
Requires:       libtota = %{version}
Group:          Development/Libraries

%description devel
Description: libfactory library (development)

%prep
%setup -q


%build
export LDFLAGS+="-Wl,--rpath=%{_prefix}/lib -Wl,--as-needed"
mkdir cmake_tmp
cd cmake_tmp
LDFLAGS="$LDFLAGS"
%cmake .. \
	-DCMAKE_INSTALL_PREFIX=%{_prefix}

make %{?jobs:-j%jobs}

%install
cd cmake_tmp
%make_install
#mkdir -p %{buildroot}/usr/lib/
cp libtota.a %{buildroot}%{_libdir}/libtota.a
%post

%posttrans
if [ ! -e /opt/data/recovery ]; then
	ln -sf /opt/data/update /opt/data/recovery
fi


%files
%defattr(-,root,root,-)
%license LICENSE.Apache-2.0
%license LICENSE.BSD-2-Clause
%license LICENSE.BSD-3-Clause
%{_libdir}/libtota.so.*
#%manifest fota.manifest

%files devel
%defattr(-,root,root,-)
%{_libdir}/libtota.so
%{_libdir}/libtota.a
%{_libdir}/pkgconfig/tota.pc
%{_includedir}/fota_common.h
%{_includedir}/fota_log.h
%{_includedir}/fota_tar.h
%{_includedir}/SS_Common.h
%{_includedir}/SS_Engine_Errors.h
%{_includedir}/SS_Engine_Update.h
%{_includedir}/SS_FSUpdate.h
%{_includedir}/SS_ImageUpdate.h
%{_includedir}/SS_MultiProcessUpdate.h
%{_includedir}/SS_Nand.h
%{_includedir}/SS_UPI.h
%{_includedir}/ua_types.h
