/*
 * libtota
 *
 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <ctype.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <mtd/mtd-user.h>
#include "SS_Nand.h"
#include "SS_ImageUpdate.h"
#include "SS_Engine_Errors.h"
#include "SS_Common.h"
#include "ua_types.h"
#include "fota_common.h"

static int local_pid;
static int local_offset;

int nand_init(void *pbUserData, char *block_file, int offset)
{

	local_pid = open(block_file, O_RDWR, 0777);
	if (local_pid < 0)
		return E_SS_FAILURE;

	local_offset = offset;
	return S_SS_SUCCESS;
}

void nand_finalize()
{
	close(local_pid);
}

unsigned long nand_block_size()
{
	return SS_GetBlockSize(NULL);
}

unsigned long nand_pages_size()
{
	return 1 << NAND_PAGE_BITS;
}

unsigned long nand_image_size(char *block_file)
{
	int fid;
	struct stat st;
	fid = open(block_file, O_RDWR, 0777);
	if (fid < 0)
		return 0;
	if (fstat(fid, &st) < 0) {
		close(fid);
		return 0;
	}
	close(fid);
	return st.st_size;
}

int nand_write(void *pbUserData, unsigned char *pbBuffer,
	       unsigned long dwBlockAddress)
{
	int ret;
	ret = lseek(local_pid, dwBlockAddress + local_offset, SEEK_SET);
	LOG("nand_write lseek =%x\n", ret);
	ret = write(local_pid, pbBuffer, nand_block_size());

	LOG("nand_write dwStartAddress local_offset =%x\n", local_offset);
	LOG("nand_write dwStartAddress dwBlockAddress =%lx\n",
	       dwBlockAddress);

	return (ret >= 0) ? S_SS_SUCCESS : E_SS_WRITE_ERROR;
}

#define LOGICAL_SECTOR 512

int nand_read(void *pbUserData, unsigned char *pbBuffer,
	      unsigned long dwStartAddress, unsigned long dwSize)
{
	int align, align2, ret;
	char *buf;
	align =
	    dwStartAddress - (dwStartAddress / LOGICAL_SECTOR) * LOGICAL_SECTOR;
	align2 =
	    (LOGICAL_SECTOR -
	     (dwSize + dwStartAddress) % LOGICAL_SECTOR) % LOGICAL_SECTOR;

	ret = lseek(local_pid, local_offset + (dwStartAddress - align), SEEK_SET);
	LOG("nand_read lseek =%x\n", ret);
	buf = malloc(align + align2 + dwSize);
	if (buf == NULL)
		return E_SS_MALLOC_ERROR;
	ret = read(local_pid, buf, align + align2 + dwSize);
	if (ret > 0)
		memcpy(pbBuffer, buf + align, dwSize);
	free(buf);

	return (ret > 0) ? S_SS_SUCCESS : E_SS_READ_ERROR;

}
*/
